<?php
if (!defined('ABSPATH')) {
    exit;
}
?>
<div class="formholder">
    <form name="g2m_adminsettings" id="g2m_adminsettings" action="" method="post"> 
        <div class="gotowpsection">
            <div class="gotowpsection-header">
                <h2>1. <?php  _e('Connect to Your GoToMeeting Account', 'g2wper'); ?></h2>
                <ul class="savebtn">
                    <input type="hidden" name="action" value="savemeetingsettings">
                    <input class="submit_btn" type="submit" name="submit" value="<?php  _e('Save Details', 'g2wper'); ?>">
                </ul>
            </div>
            <!-- end gotowpsection-header -->
            <div class="desc">
                <?php
                   $app_link = '<a href="http://app.gotowp.com" target="_blank">app.gotowp.com</a>';
                    /* translators: %s is replaced with "url" */
                   $info_text = sprintf(__('Visit %s then login with your GoToMeeting details to retrieve your Organizer Key and Access Token', 'g2wper'), $app_link); 
                ?>                
                <p><?php echo $info_text; ?></p>

            </div>
            <ul class="gotowp-admin-key">
                <li><?php  _e('Organizer Key', 'g2wper'); ?></li>
                <li><input type="text" size=40    value="<?php echo trim(get_option('gotowp_g2m_organizer_key')); ?>" name="g2m_organizer_key" id="g2m_organizer_key" /></li>
            </ul>
            <ul class="gotowp-admin-token">
                <li><?php  _e('Access Token', 'g2wper'); ?></li>
                <li><input type="text" size=40 value="<?php echo trim(get_option('gotowp_g2m_access_token')); ?>" name="g2m_access_token" id="g2m_access_token" /></li>
            </ul>
        </div>
        <!-- end gotowpsection -->
    </form>
</div>


<?php
$organizer_key = trim(get_option('gotowp_g2m_organizer_key'));
$access_token = trim(get_option('gotowp_g2m_access_token'));
?>

<?php if ($organizer_key != '' && $access_token != ''): ?>

    <div class="formholder">
        <form name="gotowp_g2m_meetings_sync_form" id="gotowp_g2m_meetings_sync_form" action="" method="post">
            <div class="gotowpsection">
                <div class="gotowpsection-header">
                    <h2>2. <?php  _e('Manage Your Meetings', 'g2wper'); ?></h2>
                    <ul class="syncbtn">
                        <li><input type="hidden" name="action" value="gotowp_g2m_update_meetings_form" /></li>
                        <li><input id="update_meetings" class="submit_btn" style="" type="submit" name="submit" value="<?php _e('Sync with GoToMeeting', 'g2wper') ?>" /></li>
                    </ul>
                </div>
            </div>
        </form>
    </div>

    <div class="formholder">
        <form class="meetings-form" name="gotowp_g2m_meetings_list_form" id="gotowp_g2m_meetings_list_form" action="" method="post">
            <div class="gotowpsection">
                <div class="desc">
                    <p><?php  _e('Manage Meetings below', 'g2wper'); ?>.</p>
                </div>

                <?php $meetings = gotowp_g2m_json_decode(gotowp_g2m_get_meetings()); ?>

                <?php if ($meetings && !isset($meetings->errorCode) && !isset($meetings->int_err_code)): ?>

                    <div class="webinar-container meetings-list">
                        <div class="webinar-list-heading">
                            <div class="col name"><?php _e('Name', 'g2wper'); ?></div>
                            <!--<div class="col"><?php _e('Meeting ID', 'g2wper'); ?></div>-->
                            <div class="col"><?php _e('Date', 'g2wper'); ?></div>
                            <div class="col"><?php _e('Description', 'g2wper'); ?></div>
                            <div class="col"><?php _e('# of registrations', 'g2wper'); ?></div>
                            <div class="col"><?php _e(''); ?></div>
                        </div><!-- webinar-list-heading -->

                        <?php
                        foreach ($meetings as $meeting) :

                            $meeting_key = $meeting->meetingId;
                            $meeting_key = trim($meeting_key);

                            $meeting_obj = gotowp_g2m_get_meeting($meeting_key);

                            $subject = $meeting->subject;


                            if ($meeting->meetingType == 'scheduled') {
                                $startTime = new Gotowpg2mDateTime($meeting->startTime);
                                $endTime = new Gotowpg2mDateTime($meeting->endTime);
                                $date_title = $startTime->format('D, M j, Y h:i A');
                                $sec_diff = $endTime->getTimestamp() - $startTime->getTimestamp();
                                if ($sec_diff > 60) {
                                    $date_title .= ' - ' . $endTime->format('h:i A');
                                }
                                $date_title .= $endTime->format(' T');
                            } else {
                                $date_title = __('Recurring Meeting' , 'g2wper');
                            }
                            ?>

                            <div class="webinar-list-details" data-meetid="<?php echo $meeting_key; ?>"  data-type="meeting">
                                <div class="details-main">
                                    <div class="col name"><?php echo $subject; ?></div>
                                    <!--<div class="col webinat_id"><?php echo $meeting_key; ?></div>-->
                                    <div class="col date"><?php echo $date_title; ?></div>
                                </div><!-- end details-main -->
                                <div class="details-sub">

                                    <div class="col meeting-shortcode">
                                        <a class="copyshortcode" href="javascript:void(0);"><?php  _e('Copy Shortcode', 'g2wper'); ?></a>
                                    </div>   
                                </div><!-- end details-sub -->                                         
                            </div><!-- end webinar-list-details -->

                        <?php endforeach; ?>
                    </div><!-- webinar-container -->




                <?php endif; ?>


            </div>
        </form>
    </div>  

<?php endif; ?>