<?php
if (!defined('ABSPATH')) {
    exit;
}
$g2w_page = admin_url('options-general.php?gtproduct=g2w&page=gotowp_personal#tab1_content');
$g2w_page = rawurlencode($g2w_page);

$client_id = GOTOWP_PERSONAL_G2W_CONSUMER_KEY;

$refresh_token = get_option('gotowp_premium_refresh_token');
?>


<div class="formholder">
    <form name="adminsettings" id="adminsettings" action="" method="post">
        <div class="gotowpsection">
            <div class="gotowpsection-header">
                <h2>1. <?php  _e('Connect to Your GoToWebinar Account', 'g2wper'); ?></h2>
                <ul class="savebtn">
                    <input type="hidden" name="action" value="savewebinarsettings">
                    <input class="submit_btn" type="submit" name="submit" value="<?php  _e('Save Details', 'g2wper'); ?>">
                </ul>
            </div>
            <!-- end gotowpsection-header -->
            <div class="desc">
                <?php if (!$refresh_token): ?>
                    <p>
                        <?php echo '<a style="display: inline-block; margin-top: 15px;" class="button-secondary gotowebinar-authorisation-button" href="https://api.getgo.com/oauth/v2/authorize?response_type=code&amp;client_id=' . $client_id . '&amp;state=' . $g2w_page . '">'.__('Connect with GoToWebinar', 'g2wper').'</a>'; ?>
                    </p>
                <?php endif; ?>                    
            <!--<p>Visit <a href="http://app.gotowp.com" target="_blank">app.gotowp.com</a> then login with your GoToWebinar details to retrieve your Organizer Key and Access Token</p>-->
            </div>
            <ul class="gotowp-admin-key">
                <li><?php  _e('Organizer Key', 'g2wper'); ?></li>
                <li><input type="text" size=40    value="<?php echo trim(get_option('gotowp_premium_organizer_key')); ?>" name="organizer_key" id="organizer_key" /></li>
            </ul>
            <ul class="gotowp-admin-token">
                <li><?php  _e('Access Token', 'g2wper'); ?></li>
                <li><input type="text" size=40 value="<?php echo trim(get_option('gotowp_premium_access_token')); ?>" name="access_token" id="access_token" /></li>
            </ul>
            <ul class="gotowp-admin-platform">
                <li><?php  _e('Platform', 'g2wper'); ?></li>
                <li><select name="woo_platform_type" id="woo_platform_type">
                        <option value="GLOBAL"
                                <?php if (trim(get_option('gotowp_premium_woo_platform_type')) == 'GLOBAL') echo "selected" ?>><?php  _e('GLOBAL', 'g2wper'); ?></option>
                        <option value="LEGACY"
                                <?php if (trim(get_option('gotowp_premium_woo_platform_type')) == 'LEGACY') echo "selected" ?>><?php  _e('LEGACY', 'g2wper'); ?></option>
                    </select></li>
            </ul>
        </div>
        <!-- end gotowpsection -->
    </form>
</div>


<?php
$organizer_key = trim(get_option('gotowp_premium_organizer_key'));
$access_token = trim(get_option('gotowp_premium_access_token'));
?>    

<?php if ($organizer_key != '' && $access_token != ''): ?>

    <?php
    $site_url = get_option('siteurl');
    $webinar_price_check = get_option('gotowp_premium_webinar_price_check');
    $checked = '';
    if ($webinar_price_check == 1) {
        $checked = 'checked="checked"';
    }
    ?>    

    <div class="formholder">
        <form name="webinarprices" id="webinarprices" action="<?php echo admin_url('options-general.php') . '?page=gotowp_personal'; ?>" method="post">
            <div class="gotowpsection">
                <div class="desc">
                    <p><?php  _e('If you want to set the same price for all your webinars, simply check the box below, specify the price, then click save', 'g2wper'); ?>.</p>
                </div>
                <ul class="universal">
                    <li class="checkbox"><input <?php echo $checked; ?> type="checkbox" size="68" value="<?php echo get_option('gotowp_premium_webinar_price_check'); ?>" name="check_webinar_price" id="check_webinar_price" /><?php  _e('Use Universal Price for All Webinars', 'g2wper'); ?></li>
                    <li class="price"><?php  _e('Price', 'g2wper'); ?><input class="number" type="text" size="10" style="text-align: center;" value="<?php echo get_option('gotowp_premium_webinar_price_all'); ?>" name="webinar_price_all" id="webinar_price_all" /></li>
                </ul>
                <div class="savepricebtn">
                    <input type="hidden" name="action" value="webinarpriceall">
                    <input type="submit" class="submit_btn" name="webinarpriceall_submit" id="webinarpriceall_submit" value="<?php  _e('Save Universal Price', 'g2wper'); ?>">
                </div>
                <!-- end savebtn -->
            </div>
            <!-- end gotowpsection -->
        </form>
    </div>




    <div class="formholder">
        <form name="gtwbundle_webinars_form" id="gtwbundle_webinars_form" action="<?php echo admin_url('options-general.php') . '?page=gotowp_personal'; ?>" method="post">
            <div class="gotowpsection">
                <div class="gotowpsection-header">
                    <h2>2. <?php  _e('Manage Your Webinars', 'g2wper'); ?></h2>
                    <ul class="syncbtn">
                        <li><input type="hidden" name="action" value="gotowp_personal_update_webinars_form"></li>
                        <li><input id="update_webinars" class="submit_btn" style="" type="submit" name="submit" value="<?php  _e('Sync with GoToWebinar', 'g2wper'); ?>"></li>
                    </ul>
                </div>
            </div>
        </form>
    </div>

    <div class="formholder">
        <form name="gtwbundle_webinars_form" id="gtwbundle_webinars_form" action="<?php echo admin_url('options-general.php') . '?page=gotowp_personal'; ?>" method="post">
            <div class="gotowpsection">
                <div class="desc">
                    <p><?php  _e('Manage webinars below', 'g2wper'); ?>.</p>
                </div>

                <?php $webinars = gotowp_personal_json_decode(gotowp_personal_get_webinars()); ?>

                <?php if ($webinars && !isset($webinars->errorCode) && !isset($webinars->int_err_code)): ?>

                    <div class="webinar-container">
                        <div class="webinar-list-heading">
                            <div class="col name"><?php _e('Name', 'g2wper'); ?></div>
                            <!--<div class="col"><?php _e('Webinar ID', 'g2wper'); ?></div>-->
                            <div class="col"><?php _e('Date', 'g2wper'); ?></div>
                            <div class="col"><?php _e('Description', 'g2wper'); ?></div>
                            <div class="col"><?php _e('# of registrations', 'g2wper'); ?></div>
                            <div class="col"><?php _e('Price', 'g2wper'); ?></div>
                            <div class="col"><?php _e(''); ?></div>
                        </div><!-- webinar-list-heading -->

                        <?php
                        
                          
                        foreach ($webinars as $webinar) :

                            $webinar_key = $webinar->webinarKey;
                            $webinar_key = trim($webinar_key);
                            $webinar_option_key = 'gotowp_premium_webinar_price_' . $webinar_key;
                            $price1 = get_option($webinar_option_key);
                            $webinar_source_key = 'gotowp_premium_webinar_source_' . $webinar_key;
                            $source = get_option($webinar_source_key);
                            $resi_count = gotowp_personal_get_registrants_count($webinar_key);
                            $subject = $webinar->subject;
                            $timezone_string = $webinar->timeZone;
                            $startTime = new GotowppreDateTime($webinar->times [0]->startTime);
                            $startTime->setTimezone(new DateTimeZone($timezone_string));
                            $endTime = new GotowppreDateTime($webinar->times [0]->endTime);
                            $endTime->setTimezone(new DateTimeZone($timezone_string));
                            $date_title = $startTime->format('D, M j, Y h:i A');
                            $sec_diff = $endTime->getTimestamp() - $startTime->getTimestamp();
                            if ($sec_diff > 60) {
                                $date_title .= ' - ' . $endTime->format('h:i A');
                            }
                            $date_title .= $endTime->format(' T');
                            ?>

                            <div class="webinar-list-details" data-webid="<?php echo $webinar_key; ?>" data-type="webinar">
                                <div class="details-main">
                                    <div class="col name"><?php echo $subject; ?></div>
                                                                                    <!--<div class="col webinat_id"><?php echo $webinar_key; ?></div>-->
                                    <div class="col date"><?php echo $date_title; ?></div>
                                    <div class="col description"><?php echo $webinar->description; ?></div>
                                </div><!-- end details-main -->
                                <div class="details-sub">
                                    <div class="col count"><?php  _e('# of Registrations', 'g2wper'); ?>: <?php echo $resi_count; ?></div>
                                    <div class="col price">
                                        <?php  _e('Price', 'g2wper'); ?>: <input type="text" size="7" class="number" value="<?php echo $price1; ?>" name="<?php echo $webinar_option_key; ?>" id="<?php echo $webinar_option_key; ?>" />
                                    </div>
                                    <div class="col source">
                                        <?php  _e('Source', 'g2wper'); ?>: <input type="text" size="20" class="number" value="<?php echo $source; ?>" name="<?php echo $webinar_source_key; ?>" id="<?php echo $webinar_source_key; ?>" />
                                    </div>                                                    
                                    <div class="col webinar-shortcode">
                                        <a class="copyshortcode" href="javascript:void(0);"><?php  _e('Copy Shortcode', 'g2wper'); ?></a>
                                    </div>   
                                </div><!-- end details-sub -->                                         
                            </div><!-- end webinar-list-details -->

                        <?php endforeach; ?>
                    </div><!-- webinar-container -->

                    <div class="savepricebtn">
                        <input type="hidden" name="action" value="webinarprice" />
                        <input type="submit" class="submit_btn" name="webinarprice_submit" id="webinarprice_submit" value="<?php _e('Save Prices', 'g2wper') ?>" />
                    </div><!-- end savebtn -->



                <?php endif; ?>


            </div>
        </form>
    </div>  

<?php endif; ?>