<?php
if (!defined('ABSPATH')) {
    exit;
}
?>
<div class="mainsection-header">
    <h2><?php _e('Emails Settings', 'g2wper'); ?></h2>
</div>

<div class="gotowp-left">
    <div class="formholder">
        <form name="messagesettings" id="messagesettings" action="" method="post">
            <div class="gotowpsection">
                <div class="gotowpsection-header">
                    <h2>1. <?php _e('Subject & Message Settings', 'g2wper'); ?></h2>
                    <ul class="savebtn">
                        <input type="hidden" name="action" value="save_message" />
                        <input type="button" name="message_submit" id="message_submit" class="submit_btn" value="<?php _e('Save Message', 'g2wper') ?>" />
                    </ul>
                </div>
                <!-- end gotowpsection-header -->
                <div class="desc">
                    <?php
                    $wc_email_link = '<a href="' . admin_url("page=wc-settings&tab=email") . '">Email Settings</a>';
                    /* translators: %s is replaced with "url" */
                    $info_text = sprintf(__('If you are selling webinars using the shortcode, you can setup email notifications for people in your organization below. When a webinar is purchased, those added to the list below will receive the email containing info you\'ve outlined below. (Note: if you\'re using Woo Commerce integration, you can ignore this section, as Woo Commerce handles order emails separately in their %s tab', 'g2wper'),$wc_email_link);

                    ?>
                    <p><?php echo $info_text; ?>.</p>
                </div>
                <div class="content-inner">
                    <ul>
                        <li><?php _e('Subject', 'g2wper'); ?></li>
                        <li><input type="text" size="50" value="<?php echo get_option('gotowp_premium_subject'); ?>" name="subject_name" id="subject_name" /></li>
                    </ul>
                    <ul>
                        <li><?php _e('Reply To', 'g2wper'); ?></li>
                        <li><input type="text" size="50" value="<?php echo get_option('gotowp_premium_replyto'); ?>" name="replyto" id="replyto" /></li>
                    </ul>
                    <ul>
                        <li><?php _e('Message', 'g2wper'); ?></li>
                        <li><textarea rows="4" cols="65" name="message" id="message"><?php echo get_option('gotowp_premium_message'); ?></textarea></li>
                    </ul>
                </div>

            </div>
            <!-- end gotowpsection -->
        </form>
    </div>
</div>    

<div class="gotowp-right">
    <div class="formholder">
        <form name="emailsettings" id="emailsettings" action="" method="post">
            <div class="gotowpsection">
                <div class="gotowpsection-header">
                    <h2><?php _e('Email Addresses That Will Receive Notification', 'g2wper'); ?></h2>
                </div>
                <!-- end gotowpsection-header -->
                <div class="desc">
                    <p><?php echo $info_text; ?>.</p>
                </div>
                <div class="content-inner">
                    <ul id="addnewemail">
                        <li class="error-msgs"></li>
                        <li><?php _e('Add Email Address', 'g2wper'); ?></li>
                        <li><input type="text" size="41" value="" name="email_new" id="email_new" />
                            <input type="button" name="email_new_submit" id="email_new_submit" value="+ <?php _e('Add', 'g2wper') ?>" /></li>
                    </ul>

                    <ul id="emailaddresses">
                        <?php
                        $email_options = get_emails_options();
                        $i = 1;
                        foreach ($email_options as $name => $value):
                            ?>
                            <li>
                                <input type="text" size="41" value="<?php echo $value; ?>" name="<?php echo $name; ?>" id="<?php echo $name; ?>" />
                                <input type="button" name="edit_email_submit" class="edit_email_submit" value="<?php _e('Save', 'g2wper') ?>" />
                                <input type="button" name="remove_email_submit" class="remove_email_submit" value="<?php _e('Remove', 'g2wper') ?>" />                         
                            </li>
                            <?php
                            $i++;
                        endforeach;
                        ?>
                    </ul>
                </div>

            </div>
            <!-- end gotowpsection -->
        </form>
    </div>

</div>

