<?php
if (!defined('ABSPATH')) {
    exit;
}
?>
<div class="mainsection-header">
    <h2><?php _e('Payment Settings', 'g2wper'); ?></h2>
</div>
<div class="gotowp-left">
    <div class="formholder">
        <form name="adminsettings" id="adminsettings" action="" method="post">
            <div class="gotowpsection">
                <div class="gotowpsection-header">
                    <h2><?php _e('Paypal', 'g2wper'); ?></h2>
                    <ul class="savebtn">
                        <input type="hidden" name="action" value="savepaypalpayment" />
                        <input class="submit_btn" type="submit" name="submit" value="<?php _e('Save Details', 'g2wper') ?>" />
                    </ul>
                </div>
                <!-- end gotowpsection-header -->
                <div class="desc">
                    <?php
                    $wc_checkout_link = '<a href="' . admin_url("page=wc-settings&tab=checkout") . '">Checkout</a>';
                    /* translators: %s is replaced with "url" */
                    $info_text = sprintf(__('If you\'re selling webinars with the shortcode, specify the payment settings below. If you\'re using Woo Commerce integration, setup your desired payment gateways on their %s tab', 'g2wper'),$wc_checkout_link);
                    ?>
                    <p><?php echo $info_text; ?>.</p>
                </div>
                <div class="content-inner">
                    <ul>
                        <li><?php _e('Paypal Email', 'g2wper'); ?></li>
                        <li><input type="text" size=40 value="<?php echo trim(get_option('gotowp_premium_payment_email')); ?>" name="payment_email" id="payment_email" /></li>
                    </ul>
                    <ul>
                        <li><?php _e('Paypal Mode', 'g2wper'); ?></li>
                        <li><select name="payment_mode" id="payment_mode">
                                <option value="LIVE" <?php if (get_option('gotowp_premium_payment_mode') == 'LIVE') echo "selected" ?>><?php _e('LIVE', 'g2wper'); ?></option>
                                <option value="SANDBOX" <?php if (get_option('gotowp_premium_payment_mode') == 'SANDBOX') echo "selected" ?>><?php _e('SANDBOX', 'g2wper'); ?></option>
                                <option value="DISABLE" <?php if (get_option('gotowp_premium_payment_mode') == 'DISABLE') echo "selected" ?>><?php _e('DISABLE', 'g2wper'); ?></option>
                            </select></li>
                    </ul>
                    <ul>
                        <li><?php _e('Currency Code', 'g2wper'); ?></li>
                        <?php $curr_currency = get_option('gotowp_premium_currency_code'); ?>
                        <li><select name="currency_code" id="currency_code">
                                <option value="USD" <?php if ($curr_currency == 'USD') echo "selected"; ?>>US Dollar</option>
                                <option value="EUR" <?php if ($curr_currency == 'EUR') echo "selected"; ?>>Euro</option>
                                <option value="CAD" <?php if ($curr_currency == 'CAD') echo "selected"; ?>>Canadian Dollar</option>
                                <option value="GBP" <?php if ($curr_currency == 'GBP') echo "selected"; ?>>British Pound</option>
                                <option value="NOK" <?php if ($curr_currency == 'NOK') echo "selected"; ?>>Norwegian Krone</option>
                                <option value="SEK" <?php if ($curr_currency == 'SEK') echo "selected"; ?>>Swedish Krona</option>
                                <option value="NZD" <?php if ($curr_currency == 'NZD') echo "selected"; ?>>New Zealand Dollar</option>
                            </select></li>
                    </ul>
                    <ul class="width100">
                        <li><?php _e('use LIVE for live mode and SANDBOX for sandbox mode', 'g2wper'); ?></li>
                    </ul>
                    <ul>
                        <li><?php _e('Paypal IPN Url', 'g2wper'); ?></li>
                        <li><input type="text" size=40 value="<?php echo $paypal_ipn_url; ?>" name="paypal_ipn_url" id="paypal_ipn_url" /></li>
                    </ul>
                    <ul class="width100">
                        <li><?php _e('try above paypal ipn url if it does not shows 404 its correct one else provide correct url', 'g2wper'); ?></td>
                    </ul>
                </div>

            </div>
            <!-- end gotowpsection -->
        </form>
    </div>
</div>    

<div class="gotowp-right">
    <div class="formholder">
        <form name="adminsettings" id="adminsettings" action="" method="post">
            <div class="gotowpsection">
                <div class="gotowpsection-header">
                    <h2>Authorize.net</h2>
                    <ul class="savebtn">
                        <input type="hidden" name="action" value="saveauthorizepayment" />
                        <input class="submit_btn" type="submit" name="submit" value="<?php _e('Save Details', 'g2wper') ?>" />
                    </ul>                
                </div>
                <!-- end gotowpsection-header -->
                <div class="desc">
                    <p><?php echo $info_text; ?>.</p>
                </div>
                <div class="content-inner">
                    <ul>
                        <li><?php _e('API Login Id', 'g2wper'); ?></li>
                        <li><input type="text" size=40 value="<?php echo get_option('gotowp_premium_authorizenet_api_login_id'); ?>" name="authorizenet_api_login_id" id="authorizenet_api_login_id" /></li>
                    </ul>
                    <ul>
                        <li><?php _e('Transaction Key', 'g2wper'); ?></li>
                        <li><input type="text" size=40 value="<?php echo get_option('gotowp_premium_authorizenet_transaction_key'); ?>" name="authorizenet_transaction_key" id="authorizenet_transaction_key" /></li>
                    </ul>
                    <ul>
                        <li><?php _e('Authorize.net Mode', 'g2wper'); ?></li>
                        <li><select name="authorize_payment_mode" id="authorize_payment_mode">
                                <option value="LIVE" <?php if (get_option('gotowp_premium_authorizenet_mode') == 'LIVE') echo "selected" ?>><?php _e('LIVE', 'g2wper'); ?></option>
                                <option value="SANDBOX" <?php if (get_option('gotowp_premium_authorizenet_mode') == 'SANDBOX') echo "selected" ?>><?php _e('SANDBOX', 'g2wper'); ?></option>
                                <option value="DISABLE" <?php if (get_option('gotowp_premium_authorizenet_mode') == 'DISABLE') echo "selected" ?>><?php _e('DISABLE', 'g2wper'); ?></option>
                            </select></li>
                    </ul>
                    <ul class="width100">
                        <li><?php _e('use LIVE for live mode and SANDBOX for sandbox mode', 'g2wper'); ?></li>
                    </ul>
                </div>

            </div>
            <!-- end gotowpsection -->
        </form>
    </div>

</div>

